import{S as sn,i as on,s as nn,e as n,k as p,w as _,t as s,M as rn,c as r,d as t,m as d,a as i,x as v,h as o,b as c,N as an,G as a,g as h,y as b,L as ln,q as y,o as k,B as E,v as hn}from"../chunks/vendor-hf-doc-builder.js";import{I as ct}from"../chunks/IconCopyLink-hf-doc-builder.js";import{C as xe}from"../chunks/CodeBlock-hf-doc-builder.js";function pn(Us){let q,ft,P,z,Re,Q,ia,Se,la,ut,L,ha,Ce,pa,da,Y,ca,fa,mt,x,M,Fe,J,ua,ze,ma,gt,$,ga,V,wa,_a,Me,va,ba,wt,u,ya,K,Oe,ka,Ea,Ie,La,$a,Ge,Aa,ja,X,Ta,qa,_t,ce,Pa,vt,fe,xa,bt,ue,Ra,yt,me,ge,Qs,kt,f,Sa,De,Ca,Fa,Be,za,Ma,We,Oa,Ia,He,Ga,Da,Ne,Ba,Wa,Ue,Ha,Na,Et,Z,Lt,R,O,Qe,ee,Ua,Ye,Qa,$t,I,Ya,te,Ja,Va,At,we,Ka,jt,_e,ve,Ys,Tt,be,Xa,qt,w,Za,Je,es,ts,Ve,as,ss,Ke,os,ns,Pt,ae,xt,ye,rs,Rt,g,Xe,is,ls,se,hs,ps,oe,ds,cs,Ze,fs,us,St,ke,ms,Ct,S,G,et,ne,gs,tt,ws,Ft,Ee,_s,zt,A,vs,at,bs,ys,st,ks,Es,Mt,D,Ls,ot,$s,As,Ot,re,It,B,js,nt,Ts,qs,Gt,ie,Dt,Le,Ps,Bt,C,W,rt,le,xs,it,Rs,Wt,$e,Ss,Ht,j,lt,Cs,Fs,ht,zs,Ms,pt,Os,Nt,Ae,Is,Ut,he,Qt,H,Gs,dt,Ds,Bs,Yt,pe,Jt,N,Ws,de,Hs,Ns,Vt;return Q=new ct({}),J=new ct({}),Z=new xe({props:{code:`accelerate launch --multi_gpu --num_machines 1  --num_processes 8 my_accelerate_script.py
torchrun --nnodes 1  --nproc_per_node 8 my_torch_script.py`,highlighted:`accelerate launch --multi_gpu --num_machines 1  --num_processes 8 my_accelerate_script.py
torchrun --nnodes 1  --nproc_per_node 8 my_torch_script.py`}}),ee=new ct({}),ae=new xe({props:{code:`# load model in 8bit
model = AutoModelForCausalLM.from_pretrained(
        args.model_path,
        load_in_8bit=True,
        device_map={"": Accelerator().local_process_index}
    )
model = prepare_model_for_int8_training(model)

# add LoRA to model
lora_config = LoraConfig(
    r=16,
    lora_alpha=32,
    lora_dropout=0.05,
    bias="none",
    task_type="CAUSAL_LM",
)

model = get_peft_model(model, config)`,highlighted:`<span class="hljs-comment"># load model in 8bit</span>
model = AutoModelForCausalLM.from_pretrained(
        args.model_path,
        load_in_8bit=<span class="hljs-literal">True</span>,
        device_map={<span class="hljs-string">&quot;&quot;</span>: Accelerator().local_process_index}
    )
model = prepare_model_for_int8_training(model)

<span class="hljs-comment"># add LoRA to model</span>
lora_config = LoraConfig(
    r=<span class="hljs-number">16</span>,
    lora_alpha=<span class="hljs-number">32</span>,
    lora_dropout=<span class="hljs-number">0.05</span>,
    bias=<span class="hljs-string">&quot;none&quot;</span>,
    task_type=<span class="hljs-string">&quot;CAUSAL_LM&quot;</span>,
)

model = get_peft_model(model, config)`}}),ne=new ct({}),re=new xe({props:{code:`class RewardTrainer(Trainer):
    def compute_loss(self, model, inputs, return_outputs=False):
        rewards_j = model(input_ids=inputs["input_ids_j"],  attention_mask=inputs["attention_mask_j"])[0]
        rewards_k = model(input_ids=inputs["input_ids_k"], attention_mask=inputs["attention_mask_k"])[0]
        loss = -nn.functional.logsigmoid(rewards_j - rewards_k).mean()
        if return_outputs:
            return loss, {"rewards_j": rewards_j, "rewards_k": rewards_k}
        return loss`,highlighted:`<span class="hljs-keyword">class</span> <span class="hljs-title class_">RewardTrainer</span>(<span class="hljs-title class_ inherited__">Trainer</span>):
    <span class="hljs-keyword">def</span> <span class="hljs-title function_">compute_loss</span>(<span class="hljs-params">self, model, inputs, return_outputs=<span class="hljs-literal">False</span></span>):
        rewards_j = model(input_ids=inputs[<span class="hljs-string">&quot;input_ids_j&quot;</span>],  attention_mask=inputs[<span class="hljs-string">&quot;attention_mask_j&quot;</span>])[<span class="hljs-number">0</span>]
        rewards_k = model(input_ids=inputs[<span class="hljs-string">&quot;input_ids_k&quot;</span>], attention_mask=inputs[<span class="hljs-string">&quot;attention_mask_k&quot;</span>])[<span class="hljs-number">0</span>]
        loss = -nn.functional.logsigmoid(rewards_j - rewards_k).mean()
        <span class="hljs-keyword">if</span> return_outputs:
            <span class="hljs-keyword">return</span> loss, {<span class="hljs-string">&quot;rewards_j&quot;</span>: rewards_j, <span class="hljs-string">&quot;rewards_k&quot;</span>: rewards_k}
        <span class="hljs-keyword">return</span> loss`}}),ie=new xe({props:{code:`peft_config = LoraConfig(
    task_type=TaskType.SEQ_CLS,
    inference_mode=False,
    r=8,
    lora_alpha=32,
    lora_dropout=0.1,
)`,highlighted:`peft_config = LoraConfig(
    task_type=TaskType.SEQ_CLS,
    inference_mode=<span class="hljs-literal">False</span>,
    r=<span class="hljs-number">8</span>,
    lora_alpha=<span class="hljs-number">32</span>,
    lora_dropout=<span class="hljs-number">0.1</span>,
)`}}),le=new ct({}),he=new xe({props:{code:`Question: <Query>

Answer: <Response>`,highlighted:`Question: &lt;Query&gt;

Answer: &lt;Response&gt;`}}),pe=new xe({props:{code:`for epoch, batch in tqdm(enumerate(ppo_trainer.dataloader)):
    question_tensors = batch["input_ids"]

	# sample from the policy and to generate responses
    response_tensors = ppo_trainer.generate(
        question_tensors,
        return_prompt=False,
        length_sampler=output_length_sampler,
        **generation_kwargs,
    )
    batch["response"] = tokenizer.batch_decode(response_tensors, skip_special_tokens=True)

    # Compute sentiment score
    texts = [q + r for q, r in zip(batch["query"], batch["response"])]
    pipe_outputs = sentiment_pipe(texts, **sent_kwargs)
    rewards = [torch.tensor(output[0]["score"] - script_args.reward_baseline) for output in pipe_outputs]

    # Run PPO step
    stats = ppo_trainer.step(question_tensors, response_tensors, rewards)
	# Log stats to Wandb
    ppo_trainer.log_stats(stats, batch, rewards)`,highlighted:`<span class="hljs-keyword">for</span> epoch, batch <span class="hljs-keyword">in</span> tqdm(<span class="hljs-built_in">enumerate</span>(ppo_trainer.dataloader)):
    question_tensors = batch[<span class="hljs-string">&quot;input_ids&quot;</span>]

	<span class="hljs-comment"># sample from the policy and to generate responses</span>
    response_tensors = ppo_trainer.generate(
        question_tensors,
        return_prompt=<span class="hljs-literal">False</span>,
        length_sampler=output_length_sampler,
        **generation_kwargs,
    )
    batch[<span class="hljs-string">&quot;response&quot;</span>] = tokenizer.batch_decode(response_tensors, skip_special_tokens=<span class="hljs-literal">True</span>)

    <span class="hljs-comment"># Compute sentiment score</span>
    texts = [q + r <span class="hljs-keyword">for</span> q, r <span class="hljs-keyword">in</span> <span class="hljs-built_in">zip</span>(batch[<span class="hljs-string">&quot;query&quot;</span>], batch[<span class="hljs-string">&quot;response&quot;</span>])]
    pipe_outputs = sentiment_pipe(texts, **sent_kwargs)
    rewards = [torch.tensor(output[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;score&quot;</span>] - script_args.reward_baseline) <span class="hljs-keyword">for</span> output <span class="hljs-keyword">in</span> pipe_outputs]

    <span class="hljs-comment"># Run PPO step</span>
    stats = ppo_trainer.step(question_tensors, response_tensors, rewards)
	<span class="hljs-comment"># Log stats to Wandb</span>
    ppo_trainer.log_stats(stats, batch, rewards)`}}),{c(){q=n("meta"),ft=p(),P=n("h1"),z=n("a"),Re=n("span"),_(Q.$$.fragment),ia=p(),Se=n("span"),la=s("Using LLaMA models with TRL"),ut=p(),L=n("p"),ha=s("We\u2019ve begun rolling out examples to use Meta\u2019s LLaMA models in "),Ce=n("code"),pa=s("trl"),da=s(" (see "),Y=n("a"),ca=s("Meta\u2019s LLaMA release"),fa=s(" for the original LLaMA model)."),mt=p(),x=n("h2"),M=n("a"),Fe=n("span"),_(J.$$.fragment),ua=p(),ze=n("span"),ma=s("Efficient training strategies"),gt=p(),$=n("p"),ga=s("Even training the smallest LLaMA model requires an enormous amount of memory. Some quick math: in bf16, every parameter uses 2 bytes (in fp32 4 bytes) in addition to 8 bytes used, e.g., in the Adam optimizer (see the "),V=n("a"),wa=s("performance docs"),_a=s(" in Transformers for more info). So a 7B parameter model would use "),Me=n("code"),va=s("(2+8)*7B=70GB"),ba=s(" just to fit in memory and would likely need more when you compute intermediate values such as attention scores. So you couldn\u2019t train the model even on a single 80GB A100 like that. You can use some tricks, like more efficient optimizers of half-precision training, to squeeze a bit more into memory, but you\u2019ll run out sooner or later."),wt=p(),u=n("p"),ya=s("Another option is to use Parameter-Efficient Fine-Tuning (PEFT) techniques, such as the "),K=n("a"),Oe=n("code"),ka=s("peft"),Ea=s(` library, which can perform low-rank adaptation (LoRA) on a model loaded in 8-bit.
For more on `),Ie=n("code"),La=s("peft"),$a=s(" + "),Ge=n("code"),Aa=s("trl"),ja=s(", see the "),X=n("a"),Ta=s("docs"),qa=s("."),_t=p(),ce=n("p"),Pa=s(`Loading the model in 8bit reduces the memory footprint drastically since you only need one byte per parameter for the weights (e.g. 7B LlaMa is 7GB in memory).
Instead of training the original weights directly, LoRA adds small adapter layers on top of some specific layers (usually the attention layers); thus, the number of trainable parameters is drastically reduced.`),vt=p(),fe=n("p"),xa=s(`In this scenario, a rule of thumb is to allocate ~1.2-1.4GB per billion parameters (depending on the batch size and sequence length) to fit the entire fine-tuning setup.
This enables fine-tuning larger models (up to 50-60B scale models on a NVIDIA A100 80GB) at low cost.`),bt=p(),ue=n("p"),Ra=s(`Now we can fit very large models into a single GPU, but the training might still be very slow.
The simplest strategy in this scenario is data parallelism: we replicate the same training setup into separate GPUs and pass different batches to each GPU.
With this, you can parallelize the forward/backward passes of the model and scale with the number of GPUs.`),yt=p(),me=n("p"),ge=n("img"),kt=p(),f=n("p"),Sa=s("We use either the "),De=n("code"),Ca=s("transformers.Trainer"),Fa=s(" or "),Be=n("code"),za=s("accelerate"),Ma=s(", which both support data parallelism without any code changes, by simply passing arguments when calling the scripts with "),We=n("code"),Oa=s("torchrun"),Ia=s(" or "),He=n("code"),Ga=s("accelerate launch"),Da=s(". The following runs a training script with 8 GPUs on a single machine with "),Ne=n("code"),Ba=s("accelerate"),Wa=s(" and "),Ue=n("code"),Ha=s("torchrun"),Na=s(", respectively."),Et=p(),_(Z.$$.fragment),Lt=p(),R=n("h2"),O=n("a"),Qe=n("span"),_(ee.$$.fragment),Ua=p(),Ye=n("span"),Qa=s("Supervised fine-tuning"),$t=p(),I=n("p"),Ya=s(`Before we start training reward models and tuning our model with RL, it helps if the model is already good in the domain we are interested in.
In our case, we want it to answer questions, while for other use cases, we might want it to follow instructions, in which case instruction tuning is a great idea.
The easiest way to achieve this is by continuing to train the language model with the language modeling objective on texts from the domain or task.
The `),te=n("a"),Ja=s("StackExchange dataset"),Va=s(" is enormous (over 10 million instructions), so we can easily train the language model on a subset of it."),At=p(),we=n("p"),Ka=s(`There is nothing special about fine-tuning the model before doing RLHF - it\u2019s just the causal language modeling objective from pretraining that we apply here.
To use the data efficiently, we use a technique called packing: instead of having one text per sample in the batch and then padding to either the longest text or the maximal context of the model, we concatenate a lot of texts with a EOS token in between and cut chunks of the context size to fill the batch without any padding.`),jt=p(),_e=n("p"),ve=n("img"),Tt=p(),be=n("p"),Xa=s(`With this approach the training is much more efficient as each token that is passed through the model is also trained in contrast to padding tokens which are usually masked from the loss.
If you don\u2019t have much data and are more concerned about occasionally cutting off some tokens that are overflowing the context you can also use a classical data loader.`),qt=p(),w=n("p"),Za=s("The packing is handled by the "),Je=n("code"),es=s("ConstantLengthDataset"),ts=s(" and we can then use the "),Ve=n("code"),as=s("Trainer"),ss=s(" after loading the model with "),Ke=n("code"),os=s("peft"),ns=s(". First, we load the model in int8, prepare it for training, and then add the LoRA adapters."),Pt=p(),_(ae.$$.fragment),xt=p(),ye=n("p"),rs=s(`We train the model for a few thousand steps with the causal language modeling objective and save the model.
Since we will tune the model again with different objectives, we merge the adapter weights with the original model weights.`),Rt=p(),g=n("p"),Xe=n("strong"),is=s("Disclaimer:"),ls=s(` due to LLaMA\u2019s license, we release only the adapter weights for this and the model checkpoints in the following sections.
You can apply for access to the base model\u2019s weights by filling out Meta AI\u2019s `),se=n("a"),hs=s("form"),ps=s(" and then converting them to the \u{1F917} Transformers format by running this "),oe=n("a"),ds=s("script"),cs=s(`.
Note that you\u2019ll also need to install \u{1F917} Transformers from source until the `),Ze=n("code"),fs=s("v4.28"),us=s(" is released."),St=p(),ke=n("p"),ms=s("Now that we have fine-tuned the model for the task, we are ready to train a reward model."),Ct=p(),S=n("h2"),G=n("a"),et=n("span"),_(ne.$$.fragment),gs=p(),tt=n("span"),ws=s("Reward modeling and human preferences"),Ft=p(),Ee=n("p"),_s=s(`In principle, we could fine-tune the model using RLHF directly with the human annotations.
However, this would require us to send some samples to humans for rating after each optimization iteration.
This is expensive and slow due to the number of training samples needed for convergence and the inherent latency of human reading and annotator speed.`),zt=p(),A=n("p"),vs=s(`A trick that works well instead of direct feedback is training a reward model on human annotations collected before the RL loop.
The goal of the reward model is to imitate how a human would rate a text. There are several possible strategies to build a reward model: the most straightforward way would be to predict the annotation (e.g. a rating score or a binary value for \u201Cgood\u201D/\u201Dbad\u201D).
In practice, what works better is to predict the ranking of two examples, where the reward model is presented with two candidates `),at=n("code"),bs=s("(y_k, y_j)"),ys=s(" for a given prompt "),st=n("code"),ks=s("x"),Es=s(" and has to predict which one would be rated higher by a human annotator."),Mt=p(),D=n("p"),Ls=s(`With the StackExchange dataset, we can infer which of the two answers was preferred by the users based on the score.
With that information and the loss defined above, we can then modify the `),ot=n("code"),$s=s("transformers.Trainer"),As=s(" by adding a custom loss function."),Ot=p(),_(re.$$.fragment),It=p(),B=n("p"),js=s("We utilize a subset of a 100,000 pair of candidates and evaluate on a held-out set of 50,000. With a modest training batch size of 4, we train the Llama model using the LoRA "),nt=n("code"),Ts=s("peft"),qs=s(" adapter for a single epoch using the Adam optimizer with BF16 precision. Our LoRA configuration is:"),Gt=p(),_(ie.$$.fragment),Dt=p(),Le=n("p"),Ps=s("As detailed in the next section, the resulting adapter can be merged into the frozen model and saved for further downstream use."),Bt=p(),C=n("h2"),W=n("a"),rt=n("span"),_(le.$$.fragment),xs=p(),it=n("span"),Rs=s("Reinforcement Learning from Human Feedback"),Wt=p(),$e=n("p"),Ss=s("With the fine-tuned language model and the reward model at hand, we are now ready to run the RL loop. It follows roughly three steps:"),Ht=p(),j=n("ol"),lt=n("li"),Cs=s("Generate responses from prompts,"),Fs=p(),ht=n("li"),zs=s("Rate the responses with the reward model,"),Ms=p(),pt=n("li"),Os=s("Run a reinforcement learning policy-optimization step with the ratings."),Nt=p(),Ae=n("p"),Is=s("The Query and Response prompts are templated as follows before being tokenized and passed to the model:"),Ut=p(),_(he.$$.fragment),Qt=p(),H=n("p"),Gs=s(`The same template was used for SFT, RM and RLHF stages.
Once more, we utilize `),dt=n("code"),Ds=s("peft"),Bs=s(` for memory-efficient training, which offers an extra advantage in the RLHF context.
Here, the reference model and policy share the same base, the SFT model, which we load in 8-bit and freeze during training.
We exclusively optimize the policy\u2019s LoRA weights using PPO while sharing the base model\u2019s weights.`),Yt=p(),_(pe.$$.fragment),Jt=p(),N=n("p"),Ws=s("For the rest of the details adn evaluation, please refer to our "),de=n("a"),Hs=s("blog post on StackLLaMA"),Ns=s("."),this.h()},l(e){const l=rn('[data-svelte="svelte-1phssyn"]',document.head);q=r(l,"META",{name:!0,content:!0}),l.forEach(t),ft=d(e),P=r(e,"H1",{class:!0});var Kt=i(P);z=r(Kt,"A",{id:!0,class:!0,href:!0});var Js=i(z);Re=r(Js,"SPAN",{});var Vs=i(Re);v(Q.$$.fragment,Vs),Vs.forEach(t),Js.forEach(t),ia=d(Kt),Se=r(Kt,"SPAN",{});var Ks=i(Se);la=o(Ks,"Using LLaMA models with TRL"),Ks.forEach(t),Kt.forEach(t),ut=d(e),L=r(e,"P",{});var je=i(L);ha=o(je,"We\u2019ve begun rolling out examples to use Meta\u2019s LLaMA models in "),Ce=r(je,"CODE",{});var Xs=i(Ce);pa=o(Xs,"trl"),Xs.forEach(t),da=o(je," (see "),Y=r(je,"A",{href:!0,rel:!0});var Zs=i(Y);ca=o(Zs,"Meta\u2019s LLaMA release"),Zs.forEach(t),fa=o(je," for the original LLaMA model)."),je.forEach(t),mt=d(e),x=r(e,"H2",{class:!0});var Xt=i(x);M=r(Xt,"A",{id:!0,class:!0,href:!0});var eo=i(M);Fe=r(eo,"SPAN",{});var to=i(Fe);v(J.$$.fragment,to),to.forEach(t),eo.forEach(t),ua=d(Xt),ze=r(Xt,"SPAN",{});var ao=i(ze);ma=o(ao,"Efficient training strategies"),ao.forEach(t),Xt.forEach(t),gt=d(e),$=r(e,"P",{});var Te=i($);ga=o(Te,"Even training the smallest LLaMA model requires an enormous amount of memory. Some quick math: in bf16, every parameter uses 2 bytes (in fp32 4 bytes) in addition to 8 bytes used, e.g., in the Adam optimizer (see the "),V=r(Te,"A",{href:!0,rel:!0});var so=i(V);wa=o(so,"performance docs"),so.forEach(t),_a=o(Te," in Transformers for more info). So a 7B parameter model would use "),Me=r(Te,"CODE",{});var oo=i(Me);va=o(oo,"(2+8)*7B=70GB"),oo.forEach(t),ba=o(Te," just to fit in memory and would likely need more when you compute intermediate values such as attention scores. So you couldn\u2019t train the model even on a single 80GB A100 like that. You can use some tricks, like more efficient optimizers of half-precision training, to squeeze a bit more into memory, but you\u2019ll run out sooner or later."),Te.forEach(t),wt=d(e),u=r(e,"P",{});var T=i(u);ya=o(T,"Another option is to use Parameter-Efficient Fine-Tuning (PEFT) techniques, such as the "),K=r(T,"A",{href:!0,rel:!0});var no=i(K);Oe=r(no,"CODE",{});var ro=i(Oe);ka=o(ro,"peft"),ro.forEach(t),no.forEach(t),Ea=o(T,` library, which can perform low-rank adaptation (LoRA) on a model loaded in 8-bit.
For more on `),Ie=r(T,"CODE",{});var io=i(Ie);La=o(io,"peft"),io.forEach(t),$a=o(T," + "),Ge=r(T,"CODE",{});var lo=i(Ge);Aa=o(lo,"trl"),lo.forEach(t),ja=o(T,", see the "),X=r(T,"A",{href:!0,rel:!0});var ho=i(X);Ta=o(ho,"docs"),ho.forEach(t),qa=o(T,"."),T.forEach(t),_t=d(e),ce=r(e,"P",{});var po=i(ce);Pa=o(po,`Loading the model in 8bit reduces the memory footprint drastically since you only need one byte per parameter for the weights (e.g. 7B LlaMa is 7GB in memory).
Instead of training the original weights directly, LoRA adds small adapter layers on top of some specific layers (usually the attention layers); thus, the number of trainable parameters is drastically reduced.`),po.forEach(t),vt=d(e),fe=r(e,"P",{});var co=i(fe);xa=o(co,`In this scenario, a rule of thumb is to allocate ~1.2-1.4GB per billion parameters (depending on the batch size and sequence length) to fit the entire fine-tuning setup.
This enables fine-tuning larger models (up to 50-60B scale models on a NVIDIA A100 80GB) at low cost.`),co.forEach(t),bt=d(e),ue=r(e,"P",{});var fo=i(ue);Ra=o(fo,`Now we can fit very large models into a single GPU, but the training might still be very slow.
The simplest strategy in this scenario is data parallelism: we replicate the same training setup into separate GPUs and pass different batches to each GPU.
With this, you can parallelize the forward/backward passes of the model and scale with the number of GPUs.`),fo.forEach(t),yt=d(e),me=r(e,"P",{});var uo=i(me);ge=r(uo,"IMG",{src:!0,alt:!0}),uo.forEach(t),kt=d(e),f=r(e,"P",{});var m=i(f);Sa=o(m,"We use either the "),De=r(m,"CODE",{});var mo=i(De);Ca=o(mo,"transformers.Trainer"),mo.forEach(t),Fa=o(m," or "),Be=r(m,"CODE",{});var go=i(Be);za=o(go,"accelerate"),go.forEach(t),Ma=o(m,", which both support data parallelism without any code changes, by simply passing arguments when calling the scripts with "),We=r(m,"CODE",{});var wo=i(We);Oa=o(wo,"torchrun"),wo.forEach(t),Ia=o(m," or "),He=r(m,"CODE",{});var _o=i(He);Ga=o(_o,"accelerate launch"),_o.forEach(t),Da=o(m,". The following runs a training script with 8 GPUs on a single machine with "),Ne=r(m,"CODE",{});var vo=i(Ne);Ba=o(vo,"accelerate"),vo.forEach(t),Wa=o(m," and "),Ue=r(m,"CODE",{});var bo=i(Ue);Ha=o(bo,"torchrun"),bo.forEach(t),Na=o(m,", respectively."),m.forEach(t),Et=d(e),v(Z.$$.fragment,e),Lt=d(e),R=r(e,"H2",{class:!0});var Zt=i(R);O=r(Zt,"A",{id:!0,class:!0,href:!0});var yo=i(O);Qe=r(yo,"SPAN",{});var ko=i(Qe);v(ee.$$.fragment,ko),ko.forEach(t),yo.forEach(t),Ua=d(Zt),Ye=r(Zt,"SPAN",{});var Eo=i(Ye);Qa=o(Eo,"Supervised fine-tuning"),Eo.forEach(t),Zt.forEach(t),$t=d(e),I=r(e,"P",{});var ea=i(I);Ya=o(ea,`Before we start training reward models and tuning our model with RL, it helps if the model is already good in the domain we are interested in.
In our case, we want it to answer questions, while for other use cases, we might want it to follow instructions, in which case instruction tuning is a great idea.
The easiest way to achieve this is by continuing to train the language model with the language modeling objective on texts from the domain or task.
The `),te=r(ea,"A",{href:!0,rel:!0});var Lo=i(te);Ja=o(Lo,"StackExchange dataset"),Lo.forEach(t),Va=o(ea," is enormous (over 10 million instructions), so we can easily train the language model on a subset of it."),ea.forEach(t),At=d(e),we=r(e,"P",{});var $o=i(we);Ka=o($o,`There is nothing special about fine-tuning the model before doing RLHF - it\u2019s just the causal language modeling objective from pretraining that we apply here.
To use the data efficiently, we use a technique called packing: instead of having one text per sample in the batch and then padding to either the longest text or the maximal context of the model, we concatenate a lot of texts with a EOS token in between and cut chunks of the context size to fill the batch without any padding.`),$o.forEach(t),jt=d(e),_e=r(e,"P",{});var Ao=i(_e);ve=r(Ao,"IMG",{src:!0,alt:!0}),Ao.forEach(t),Tt=d(e),be=r(e,"P",{});var jo=i(be);Xa=o(jo,`With this approach the training is much more efficient as each token that is passed through the model is also trained in contrast to padding tokens which are usually masked from the loss.
If you don\u2019t have much data and are more concerned about occasionally cutting off some tokens that are overflowing the context you can also use a classical data loader.`),jo.forEach(t),qt=d(e),w=r(e,"P",{});var U=i(w);Za=o(U,"The packing is handled by the "),Je=r(U,"CODE",{});var To=i(Je);es=o(To,"ConstantLengthDataset"),To.forEach(t),ts=o(U," and we can then use the "),Ve=r(U,"CODE",{});var qo=i(Ve);as=o(qo,"Trainer"),qo.forEach(t),ss=o(U," after loading the model with "),Ke=r(U,"CODE",{});var Po=i(Ke);os=o(Po,"peft"),Po.forEach(t),ns=o(U,". First, we load the model in int8, prepare it for training, and then add the LoRA adapters."),U.forEach(t),Pt=d(e),v(ae.$$.fragment,e),xt=d(e),ye=r(e,"P",{});var xo=i(ye);rs=o(xo,`We train the model for a few thousand steps with the causal language modeling objective and save the model.
Since we will tune the model again with different objectives, we merge the adapter weights with the original model weights.`),xo.forEach(t),Rt=d(e),g=r(e,"P",{});var F=i(g);Xe=r(F,"STRONG",{});var Ro=i(Xe);is=o(Ro,"Disclaimer:"),Ro.forEach(t),ls=o(F,` due to LLaMA\u2019s license, we release only the adapter weights for this and the model checkpoints in the following sections.
You can apply for access to the base model\u2019s weights by filling out Meta AI\u2019s `),se=r(F,"A",{href:!0,rel:!0});var So=i(se);hs=o(So,"form"),So.forEach(t),ps=o(F," and then converting them to the \u{1F917} Transformers format by running this "),oe=r(F,"A",{href:!0,rel:!0});var Co=i(oe);ds=o(Co,"script"),Co.forEach(t),cs=o(F,`.
Note that you\u2019ll also need to install \u{1F917} Transformers from source until the `),Ze=r(F,"CODE",{});var Fo=i(Ze);fs=o(Fo,"v4.28"),Fo.forEach(t),us=o(F," is released."),F.forEach(t),St=d(e),ke=r(e,"P",{});var zo=i(ke);ms=o(zo,"Now that we have fine-tuned the model for the task, we are ready to train a reward model."),zo.forEach(t),Ct=d(e),S=r(e,"H2",{class:!0});var ta=i(S);G=r(ta,"A",{id:!0,class:!0,href:!0});var Mo=i(G);et=r(Mo,"SPAN",{});var Oo=i(et);v(ne.$$.fragment,Oo),Oo.forEach(t),Mo.forEach(t),gs=d(ta),tt=r(ta,"SPAN",{});var Io=i(tt);ws=o(Io,"Reward modeling and human preferences"),Io.forEach(t),ta.forEach(t),Ft=d(e),Ee=r(e,"P",{});var Go=i(Ee);_s=o(Go,`In principle, we could fine-tune the model using RLHF directly with the human annotations.
However, this would require us to send some samples to humans for rating after each optimization iteration.
This is expensive and slow due to the number of training samples needed for convergence and the inherent latency of human reading and annotator speed.`),Go.forEach(t),zt=d(e),A=r(e,"P",{});var qe=i(A);vs=o(qe,`A trick that works well instead of direct feedback is training a reward model on human annotations collected before the RL loop.
The goal of the reward model is to imitate how a human would rate a text. There are several possible strategies to build a reward model: the most straightforward way would be to predict the annotation (e.g. a rating score or a binary value for \u201Cgood\u201D/\u201Dbad\u201D).
In practice, what works better is to predict the ranking of two examples, where the reward model is presented with two candidates `),at=r(qe,"CODE",{});var Do=i(at);bs=o(Do,"(y_k, y_j)"),Do.forEach(t),ys=o(qe," for a given prompt "),st=r(qe,"CODE",{});var Bo=i(st);ks=o(Bo,"x"),Bo.forEach(t),Es=o(qe," and has to predict which one would be rated higher by a human annotator."),qe.forEach(t),Mt=d(e),D=r(e,"P",{});var aa=i(D);Ls=o(aa,`With the StackExchange dataset, we can infer which of the two answers was preferred by the users based on the score.
With that information and the loss defined above, we can then modify the `),ot=r(aa,"CODE",{});var Wo=i(ot);$s=o(Wo,"transformers.Trainer"),Wo.forEach(t),As=o(aa," by adding a custom loss function."),aa.forEach(t),Ot=d(e),v(re.$$.fragment,e),It=d(e),B=r(e,"P",{});var sa=i(B);js=o(sa,"We utilize a subset of a 100,000 pair of candidates and evaluate on a held-out set of 50,000. With a modest training batch size of 4, we train the Llama model using the LoRA "),nt=r(sa,"CODE",{});var Ho=i(nt);Ts=o(Ho,"peft"),Ho.forEach(t),qs=o(sa," adapter for a single epoch using the Adam optimizer with BF16 precision. Our LoRA configuration is:"),sa.forEach(t),Gt=d(e),v(ie.$$.fragment,e),Dt=d(e),Le=r(e,"P",{});var No=i(Le);Ps=o(No,"As detailed in the next section, the resulting adapter can be merged into the frozen model and saved for further downstream use."),No.forEach(t),Bt=d(e),C=r(e,"H2",{class:!0});var oa=i(C);W=r(oa,"A",{id:!0,class:!0,href:!0});var Uo=i(W);rt=r(Uo,"SPAN",{});var Qo=i(rt);v(le.$$.fragment,Qo),Qo.forEach(t),Uo.forEach(t),xs=d(oa),it=r(oa,"SPAN",{});var Yo=i(it);Rs=o(Yo,"Reinforcement Learning from Human Feedback"),Yo.forEach(t),oa.forEach(t),Wt=d(e),$e=r(e,"P",{});var Jo=i($e);Ss=o(Jo,"With the fine-tuned language model and the reward model at hand, we are now ready to run the RL loop. It follows roughly three steps:"),Jo.forEach(t),Ht=d(e),j=r(e,"OL",{});var Pe=i(j);lt=r(Pe,"LI",{});var Vo=i(lt);Cs=o(Vo,"Generate responses from prompts,"),Vo.forEach(t),Fs=d(Pe),ht=r(Pe,"LI",{});var Ko=i(ht);zs=o(Ko,"Rate the responses with the reward model,"),Ko.forEach(t),Ms=d(Pe),pt=r(Pe,"LI",{});var Xo=i(pt);Os=o(Xo,"Run a reinforcement learning policy-optimization step with the ratings."),Xo.forEach(t),Pe.forEach(t),Nt=d(e),Ae=r(e,"P",{});var Zo=i(Ae);Is=o(Zo,"The Query and Response prompts are templated as follows before being tokenized and passed to the model:"),Zo.forEach(t),Ut=d(e),v(he.$$.fragment,e),Qt=d(e),H=r(e,"P",{});var na=i(H);Gs=o(na,`The same template was used for SFT, RM and RLHF stages.
Once more, we utilize `),dt=r(na,"CODE",{});var en=i(dt);Ds=o(en,"peft"),en.forEach(t),Bs=o(na,` for memory-efficient training, which offers an extra advantage in the RLHF context.
Here, the reference model and policy share the same base, the SFT model, which we load in 8-bit and freeze during training.
We exclusively optimize the policy\u2019s LoRA weights using PPO while sharing the base model\u2019s weights.`),na.forEach(t),Yt=d(e),v(pe.$$.fragment,e),Jt=d(e),N=r(e,"P",{});var ra=i(N);Ws=o(ra,"For the rest of the details adn evaluation, please refer to our "),de=r(ra,"A",{href:!0,rel:!0});var tn=i(de);Hs=o(tn,"blog post on StackLLaMA"),tn.forEach(t),Ns=o(ra,"."),ra.forEach(t),this.h()},h(){c(q,"name","hf:doc:metadata"),c(q,"content",JSON.stringify(dn)),c(z,"id","using-llama-models-with-trl"),c(z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(z,"href","#using-llama-models-with-trl"),c(P,"class","relative group"),c(Y,"href","https://ai.facebook.com/blog/large-language-model-llama-meta-ai/"),c(Y,"rel","nofollow"),c(M,"id","efficient-training-strategies"),c(M,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(M,"href","#efficient-training-strategies"),c(x,"class","relative group"),c(V,"href","https://huggingface.co/docs/transformers/perf_train_gpu_one#optimizer"),c(V,"rel","nofollow"),c(K,"href","https://github.com/huggingface/peft"),c(K,"rel","nofollow"),c(X,"href","https://huggingface.co/docs/trl/sentiment_tuning_peft"),c(X,"rel","nofollow"),an(ge.src,Qs="https://huggingface.co/datasets/trl-internal-testing/example-images/resolve/main/blog/stackllama/chapter10_ddp.png")||c(ge,"src",Qs),c(ge,"alt","chapter10_ddp.png"),c(O,"id","supervised-finetuning"),c(O,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(O,"href","#supervised-finetuning"),c(R,"class","relative group"),c(te,"href","https://huggingface.co/datasets/HuggingFaceH4/stack-exchange-preferences"),c(te,"rel","nofollow"),an(ve.src,Ys="https://huggingface.co/datasets/trl-internal-testing/example-images/resolve/main/blog/stackllama/chapter10_preprocessing-clm.png")||c(ve,"src",Ys),c(ve,"alt","chapter10_preprocessing-clm.png"),c(se,"href","https://docs.google.com/forms/d/e/1FAIpQLSfqNECQnMkycAp2jP4Z9TFX0cGR4uf7b_fBxjY_OjhJILlKGA/viewform"),c(se,"rel","nofollow"),c(oe,"href","https://github.com/huggingface/transformers/blob/main/src/transformers/models/llama/convert_llama_weights_to_hf.py"),c(oe,"rel","nofollow"),c(G,"id","reward-modeling-and-human-preferences"),c(G,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(G,"href","#reward-modeling-and-human-preferences"),c(S,"class","relative group"),c(W,"id","reinforcement-learning-from-human-feedback"),c(W,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(W,"href","#reinforcement-learning-from-human-feedback"),c(C,"class","relative group"),c(de,"href","https://huggingface.co/blog/stackllama"),c(de,"rel","nofollow")},m(e,l){a(document.head,q),h(e,ft,l),h(e,P,l),a(P,z),a(z,Re),b(Q,Re,null),a(P,ia),a(P,Se),a(Se,la),h(e,ut,l),h(e,L,l),a(L,ha),a(L,Ce),a(Ce,pa),a(L,da),a(L,Y),a(Y,ca),a(L,fa),h(e,mt,l),h(e,x,l),a(x,M),a(M,Fe),b(J,Fe,null),a(x,ua),a(x,ze),a(ze,ma),h(e,gt,l),h(e,$,l),a($,ga),a($,V),a(V,wa),a($,_a),a($,Me),a(Me,va),a($,ba),h(e,wt,l),h(e,u,l),a(u,ya),a(u,K),a(K,Oe),a(Oe,ka),a(u,Ea),a(u,Ie),a(Ie,La),a(u,$a),a(u,Ge),a(Ge,Aa),a(u,ja),a(u,X),a(X,Ta),a(u,qa),h(e,_t,l),h(e,ce,l),a(ce,Pa),h(e,vt,l),h(e,fe,l),a(fe,xa),h(e,bt,l),h(e,ue,l),a(ue,Ra),h(e,yt,l),h(e,me,l),a(me,ge),h(e,kt,l),h(e,f,l),a(f,Sa),a(f,De),a(De,Ca),a(f,Fa),a(f,Be),a(Be,za),a(f,Ma),a(f,We),a(We,Oa),a(f,Ia),a(f,He),a(He,Ga),a(f,Da),a(f,Ne),a(Ne,Ba),a(f,Wa),a(f,Ue),a(Ue,Ha),a(f,Na),h(e,Et,l),b(Z,e,l),h(e,Lt,l),h(e,R,l),a(R,O),a(O,Qe),b(ee,Qe,null),a(R,Ua),a(R,Ye),a(Ye,Qa),h(e,$t,l),h(e,I,l),a(I,Ya),a(I,te),a(te,Ja),a(I,Va),h(e,At,l),h(e,we,l),a(we,Ka),h(e,jt,l),h(e,_e,l),a(_e,ve),h(e,Tt,l),h(e,be,l),a(be,Xa),h(e,qt,l),h(e,w,l),a(w,Za),a(w,Je),a(Je,es),a(w,ts),a(w,Ve),a(Ve,as),a(w,ss),a(w,Ke),a(Ke,os),a(w,ns),h(e,Pt,l),b(ae,e,l),h(e,xt,l),h(e,ye,l),a(ye,rs),h(e,Rt,l),h(e,g,l),a(g,Xe),a(Xe,is),a(g,ls),a(g,se),a(se,hs),a(g,ps),a(g,oe),a(oe,ds),a(g,cs),a(g,Ze),a(Ze,fs),a(g,us),h(e,St,l),h(e,ke,l),a(ke,ms),h(e,Ct,l),h(e,S,l),a(S,G),a(G,et),b(ne,et,null),a(S,gs),a(S,tt),a(tt,ws),h(e,Ft,l),h(e,Ee,l),a(Ee,_s),h(e,zt,l),h(e,A,l),a(A,vs),a(A,at),a(at,bs),a(A,ys),a(A,st),a(st,ks),a(A,Es),h(e,Mt,l),h(e,D,l),a(D,Ls),a(D,ot),a(ot,$s),a(D,As),h(e,Ot,l),b(re,e,l),h(e,It,l),h(e,B,l),a(B,js),a(B,nt),a(nt,Ts),a(B,qs),h(e,Gt,l),b(ie,e,l),h(e,Dt,l),h(e,Le,l),a(Le,Ps),h(e,Bt,l),h(e,C,l),a(C,W),a(W,rt),b(le,rt,null),a(C,xs),a(C,it),a(it,Rs),h(e,Wt,l),h(e,$e,l),a($e,Ss),h(e,Ht,l),h(e,j,l),a(j,lt),a(lt,Cs),a(j,Fs),a(j,ht),a(ht,zs),a(j,Ms),a(j,pt),a(pt,Os),h(e,Nt,l),h(e,Ae,l),a(Ae,Is),h(e,Ut,l),b(he,e,l),h(e,Qt,l),h(e,H,l),a(H,Gs),a(H,dt),a(dt,Ds),a(H,Bs),h(e,Yt,l),b(pe,e,l),h(e,Jt,l),h(e,N,l),a(N,Ws),a(N,de),a(de,Hs),a(N,Ns),Vt=!0},p:ln,i(e){Vt||(y(Q.$$.fragment,e),y(J.$$.fragment,e),y(Z.$$.fragment,e),y(ee.$$.fragment,e),y(ae.$$.fragment,e),y(ne.$$.fragment,e),y(re.$$.fragment,e),y(ie.$$.fragment,e),y(le.$$.fragment,e),y(he.$$.fragment,e),y(pe.$$.fragment,e),Vt=!0)},o(e){k(Q.$$.fragment,e),k(J.$$.fragment,e),k(Z.$$.fragment,e),k(ee.$$.fragment,e),k(ae.$$.fragment,e),k(ne.$$.fragment,e),k(re.$$.fragment,e),k(ie.$$.fragment,e),k(le.$$.fragment,e),k(he.$$.fragment,e),k(pe.$$.fragment,e),Vt=!1},d(e){t(q),e&&t(ft),e&&t(P),E(Q),e&&t(ut),e&&t(L),e&&t(mt),e&&t(x),E(J),e&&t(gt),e&&t($),e&&t(wt),e&&t(u),e&&t(_t),e&&t(ce),e&&t(vt),e&&t(fe),e&&t(bt),e&&t(ue),e&&t(yt),e&&t(me),e&&t(kt),e&&t(f),e&&t(Et),E(Z,e),e&&t(Lt),e&&t(R),E(ee),e&&t($t),e&&t(I),e&&t(At),e&&t(we),e&&t(jt),e&&t(_e),e&&t(Tt),e&&t(be),e&&t(qt),e&&t(w),e&&t(Pt),E(ae,e),e&&t(xt),e&&t(ye),e&&t(Rt),e&&t(g),e&&t(St),e&&t(ke),e&&t(Ct),e&&t(S),E(ne),e&&t(Ft),e&&t(Ee),e&&t(zt),e&&t(A),e&&t(Mt),e&&t(D),e&&t(Ot),E(re,e),e&&t(It),e&&t(B),e&&t(Gt),E(ie,e),e&&t(Dt),e&&t(Le),e&&t(Bt),e&&t(C),E(le),e&&t(Wt),e&&t($e),e&&t(Ht),e&&t(j),e&&t(Nt),e&&t(Ae),e&&t(Ut),E(he,e),e&&t(Qt),e&&t(H),e&&t(Yt),E(pe,e),e&&t(Jt),e&&t(N)}}}const dn={local:"using-llama-models-with-trl",sections:[{local:"efficient-training-strategies",title:"Efficient training strategies"},{local:"supervised-finetuning",title:"Supervised fine-tuning"},{local:"reward-modeling-and-human-preferences",title:"Reward modeling and human preferences"},{local:"reinforcement-learning-from-human-feedback",title:"Reinforcement Learning from Human Feedback"}],title:"Using LLaMA models with TRL"};function cn(Us){return hn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class gn extends sn{constructor(q){super();on(this,q,cn,pn,nn,{})}}export{gn as default,dn as metadata};
